﻿using MRTSharp.File;
using MRTSharp.Model.BGP;
using MRTSharp.Model.BGP4MP;
using MRTSharp.Model.BGP4MP.Constants;
using MRTSharp.Model.MRT;
using MRTSharp.Tasks.MRT;
using Xunit;

namespace MRTSharp.Test.Integration
{
	public class ParseMessageOpen
	{
		[Fact]
		public void Test1()
		{
			FileBuffer buffer = FileBuffer.FromBytes(new byte[] {
				0x64, 0xC0, 0x45, 0xF7, 0x00, 0x10, 0x00, 0x04, 0x00, 0x00, 0x00, 0x7A, 0x00, 0x03, 0x2A, 0xCC, 0x00, 0x00, 0x31, 0x6E, 0x00, 0x00, 0x00, 0x01, 0xB9, 0xB5, 0x3C, 0x7E, 0xC1, 0x00, 0x04, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x66, 0x01, 0x04, 0x5B, 0xA0, 0x00, 0x3C, 0xB9, 0x73, 0xF7, 0xF3, 0x49, 0x02, 0x06, 0x01, 0x04, 0x00, 0x01, 0x00, 0x01, 0x02, 0x02, 0x80, 0x00, 0x02, 0x02, 0x02, 0x00, 0x02, 0x02, 0x46, 0x00, 0x02, 0x06, 0x41, 0x04, 0x00, 0x03, 0x2A, 0xCC, 0x02, 0x02, 0x06, 0x00, 0x02, 0x06, 0x45, 0x04, 0x00, 0x01, 0x01, 0x01, 0x02, 0x0A, 0x49, 0x08, 0x06, 0x64, 0x65, 0x62, 0x69, 0x61, 0x6E, 0x00, 0x02, 0x08, 0x40, 0x06, 0x40, 0x78, 0x00, 0x01, 0x01, 0x00, 0x02, 0x09, 0x47, 0x07, 0x00, 0x01, 0x01, 0x80, 0x00, 0x00, 0x00
			});

			MRTEntry actualEntry = null;
			(new MRTTask(buffer)).Start(x => actualEntry = x);

			BGP4MPEntry bgp4MPEntry = actualEntry as BGP4MPEntry;
			Assert.NotNull(bgp4MPEntry);

			Assert.Equal(BGP4MPSubtype.BGP4MP_MESSAGE_AS4, bgp4MPEntry.Subtype);
			Assert.Equal(new(2023, 7, 25, 22, 00, 23), bgp4MPEntry.OriginateTime);

			BGP4MPMessage bgp4MPMessage = bgp4MPEntry as BGP4MPMessage;
			Assert.NotNull(bgp4MPMessage);

			Assert.NotNull(bgp4MPMessage.Message);

			BGPMessageOpen messageOpen = bgp4MPMessage.Message as BGPMessageOpen;
			Assert.NotNull(messageOpen);

			Assert.Equal(4, messageOpen.BGPVersion);

			Assert.Equal(10, messageOpen.Capabilities.Count);

		}
	}
}
